/*============================================================================
                             QUICK SORT
Reynolds' version of the original Hoare's algorithm.
=========================================================================== */
#include  <iostream.h>
void swap(int &a, int  &b) {int temp=a; a=b; b=temp;}

void printar(int A[], int size)
{for (int i=0; i<size; i=i+1) {cout << A[i] << " ";}}

void partition(const int a, const int b, int r, int& c, int X[])
{c=a; int d=b;
while (c<=d)  {if (X[c]<=r) {c++;} else
               if (X[d]>r)  {d--;} else
               {swap(X[c],X[d]);  c++; d--;};}}

void quicksort(const int a, const int b, int X[])
{int c=0;
 if (a<b) {if (X[a]>X[b]) {swap(X[a],X[b]);};
           int r=(X[a]+X[b])/2;
           partition(a+1,b-1,r,c,X);
           quicksort(a,c-1,X); quicksort(c,b,X);}}
//----------------------------------------------------------------------------
//                        max should be >= 1
void main()
{const int max = 15;
int C [max]= {61,77,80,4,36,78,39,45,89,3,7,5,38,39,56};
cout  << "\nGiven array is:\n  "; printar(C,max);
if (max > 1) {quicksort(0,max-1,C);}
cout  << "\n\nSorted array is:\n  "; printar(C,max); cout << "\n";
}
/* input:   output:
------------------------------------------------------------------------------
            Given array is:
              61 77 80 4 36 78 39 45 89 3 7 5 38 39 56

            Sorted array is:
              3 4 5 7 36 38 39 39 45 56 61 77 78 80 89
--------------------------------------------------------------------------- */